﻿package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	
	import net.nicoptere.bitmap.vectorize.Vectorize;
	import net.nicoptere.bitmap.ReduceColors;
	
	/**
	 * http://en.nicoptere.net/
	 * @author nicoptere
	 */
	
	 
	/*
	 * pic res:
	 * http://aviatechno.free.fr/bib/001j_les_monoplans_2.php
	 * http://www.libspark.org/browser/as3/PotrAs/samples/potras/demo20070929/assets
	 * */
	public class Main extends Sprite 
	{
		
		//[Embed(source = '../lib/face.png')]private var img:Class;
		//[Embed(source = '../lib/bob.png')]private var img:Class;
		//[Embed(source = '../lib/portraits.gif')]private var img:Class;
		[Embed(source = '../lib/bowser0.png')]private var img:Class;
		
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private var canvas:Shape;
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			
			
			//the source image
			var bd:BitmapData = ( new img() as Bitmap ).bitmapData;
			
			//the shape to draw to
			canvas = new Shape()
			canvas.x = canvas.y = 50;
			addChild( canvas );
			
			//target scale 
			canvas.scaleX = canvas.scaleY =  400/bd.width;
			
			
			//using my custom ReduceColor class to resample the image to a lower number of colors
			//check http://en.nicoptere.net/?p=8 for more info
			ReduceColors.toVGA( bd, false, false );
			//ReduceColors.reduceColors( bd, 3, false, true );
			
			
			//new Vectorize Object
			var vector:Vectorize = new Vectorize();
			
			//assings the bitmapData
			vector.bitmapData = bd;
			
			
			//will not take areas smaller than that into account ( spare process time )
			vector.minimumShapeArea = 2;
			
			
			//will not simplify the shapes 
			vector.vectorize();
			
			//will simplify the shapes 
			//vector.vectorize( true, { distance:10, tolerance:1 }  );
			
			
			
			//smoothes the render
			var smoothRender:Boolean = false;
			vector.draw( canvas.graphics, smoothRender );
			
			
			//returns stats on the vectorization process 
			trace( vector.info );
			
			
		}
		
	}
	
}